import * as React from 'react';
import { StyleSheet } from 'react-native';
import { RNIDetachedViewModule } from './RNIDetachedViewModule';
import { RNIDetachedNativeView } from './RNIDetachedNativeView';
export class RNIDetachedView extends React.PureComponent {
    nativeRef;
    constructor(props) {
        super(props);
        this.state = {
            isDetached: false,
        };
    }
    ;
    componentWillUnmount() {
        this.notifyComponentWillUnmount(false);
    }
    ;
    getProps() {
        const { shouldCleanupOnComponentWillUnmount, ...otherProps } = this.props;
        return {
            shouldCleanupOnComponentWillUnmount: shouldCleanupOnComponentWillUnmount ?? false,
            ...otherProps,
        };
    }
    ;
    getNativeRef = () => {
        return this.nativeRef;
    };
    getNativeReactTag = () => {
        // @ts-ignore
        return this.nativeRef?.nativeTag;
    };
    notifyComponentWillUnmount = async (isManuallyTriggered = true) => {
        const reactTag = this.getNativeReactTag();
        if (typeof reactTag !== 'number')
            return;
        await RNIDetachedViewModule.notifyComponentWillUnmount(reactTag, isManuallyTriggered);
    };
    _handleOnNativeRef = (ref) => {
        this.nativeRef = ref;
    };
    _handleOnViewDidDetach = (event) => {
        this.setState({ isDetached: true });
        this.props.onViewDidDetach?.(event);
    };
    render() {
        const props = this.getProps();
        const state = this.state;
        return React.createElement(RNIDetachedNativeView, {
            ...props,
            style: {
                ...styles.nativeView,
                ...(!state.isDetached && {
                    opacity: 0.001,
                    width: 0,
                    height: 0,
                }),
            },
            // @ts-ignore
            ref: this._handleOnNativeRef,
            onViewDidDetach: this._handleOnViewDidDetach,
        });
    }
    ;
}
;
const styles = StyleSheet.create({
    nativeView: {
        position: 'absolute',
    },
});
//# sourceMappingURL=RNIDetachedView.js.map