import * as React from 'react';
import { StyleSheet } from 'react-native';
import { RNIDummyViewModule } from './RNIDummyViewModule';
import { RNIDummyNativeView } from './RNIDummyNativeView';
export class RNIDummyView extends React.PureComponent {
    nativeRef;
    constructor(props) {
        super(props);
    }
    ;
    getProps() {
        const { shouldCleanupOnComponentWillUnmount, ...otherProps } = this.props;
        return {
            shouldCleanupOnComponentWillUnmount: shouldCleanupOnComponentWillUnmount ?? false,
            ...otherProps,
        };
    }
    ;
    componentWillUnmount() {
        this.notifyComponentWillUnmount(false);
    }
    ;
    getNativeRef = () => {
        return this.nativeRef;
    };
    getNativeReactTag = () => {
        // @ts-ignore
        return this.nativeRef?.nativeTag;
    };
    notifyComponentWillUnmount = async (isManuallyTriggered = true) => {
        const reactTag = this.getNativeReactTag();
        if (typeof reactTag !== 'number')
            return;
        await RNIDummyViewModule.notifyComponentWillUnmount(reactTag, isManuallyTriggered);
    };
    render() {
        const props = this.getProps();
        return React.createElement(RNIDummyNativeView, {
            ...props,
            style: styles.nativeDummyView,
            // @ts-ignore
            ref: this._handleOnNativeRef,
        });
    }
    ;
}
;
const styles = StyleSheet.create({
    nativeDummyView: {
        position: 'absolute',
        opacity: 0.01,
    },
});
//# sourceMappingURL=RNIDummyView.js.map